use std::fmt;

#[derive(Debug, PartialEq)]
/// Errors which can occur when parsing a host from a string
pub enum Error {
    MissingSeparator,
    EmptyDomain,
    EmptyTld,
    EmptySubdomain,
    IllegalWhitespace,
}

impl fmt::Display for Error {
    fn fmt(&self, f: &mut fmt::Formatter<'_>) -> fmt::Result {
        write!(f, "{self:?}")
    }
}

impl std::error::Error for Error {}
